/* Network.c generated by valac 0.42.6, the Vala compiler
 * generated from Network.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define DEJA_DUP_TYPE_NETWORK (deja_dup_network_get_type ())
#define DEJA_DUP_NETWORK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DEJA_DUP_TYPE_NETWORK, DejaDupNetwork))
#define DEJA_DUP_NETWORK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DEJA_DUP_TYPE_NETWORK, DejaDupNetworkClass))
#define DEJA_DUP_IS_NETWORK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DEJA_DUP_TYPE_NETWORK))
#define DEJA_DUP_IS_NETWORK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DEJA_DUP_TYPE_NETWORK))
#define DEJA_DUP_NETWORK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DEJA_DUP_TYPE_NETWORK, DejaDupNetworkClass))

typedef struct _DejaDupNetwork DejaDupNetwork;
typedef struct _DejaDupNetworkClass DejaDupNetworkClass;
typedef struct _DejaDupNetworkPrivate DejaDupNetworkPrivate;
enum  {
	DEJA_DUP_NETWORK_0_PROPERTY,
	DEJA_DUP_NETWORK_CONNECTED_PROPERTY,
	DEJA_DUP_NETWORK_METERED_PROPERTY,
	DEJA_DUP_NETWORK_NUM_PROPERTIES
};
static GParamSpec* deja_dup_network_properties[DEJA_DUP_NETWORK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _DejaDupNetworkCanReachData DejaDupNetworkCanReachData;

#define DEJA_DUP_TYPE_FILTERED_SETTINGS (deja_dup_filtered_settings_get_type ())
#define DEJA_DUP_FILTERED_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DEJA_DUP_TYPE_FILTERED_SETTINGS, DejaDupFilteredSettings))
#define DEJA_DUP_FILTERED_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DEJA_DUP_TYPE_FILTERED_SETTINGS, DejaDupFilteredSettingsClass))
#define DEJA_DUP_IS_FILTERED_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DEJA_DUP_TYPE_FILTERED_SETTINGS))
#define DEJA_DUP_IS_FILTERED_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DEJA_DUP_TYPE_FILTERED_SETTINGS))
#define DEJA_DUP_FILTERED_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DEJA_DUP_TYPE_FILTERED_SETTINGS, DejaDupFilteredSettingsClass))

typedef struct _DejaDupFilteredSettings DejaDupFilteredSettings;
typedef struct _DejaDupFilteredSettingsClass DejaDupFilteredSettingsClass;

struct _DejaDupNetwork {
	GObject parent_instance;
	DejaDupNetworkPrivate * priv;
};

struct _DejaDupNetworkClass {
	GObjectClass parent_class;
};

struct _DejaDupNetworkPrivate {
	gboolean _connected;
	gboolean _metered;
};

struct _DejaDupNetworkCanReachData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DejaDupNetwork* self;
	gchar* url;
	gboolean result;
	GNetworkMonitor* mon;
	GNetworkMonitor* _tmp0_;
	GNetworkMonitor* _tmp1_;
	GNetworkAddress* socket;
	GNetworkAddress* _tmp2_;
	gboolean _tmp3_;
	GNetworkMonitor* _tmp4_;
	GNetworkAddress* _tmp5_;
	GError* e;
	GError* _tmp6_;
	const gchar* _tmp7_;
	GError* _inner_error0_;
};


static gint DejaDupNetwork_private_offset;
static gpointer deja_dup_network_parent_class = NULL;
static DejaDupNetwork* deja_dup_network_singleton;
static DejaDupNetwork* deja_dup_network_singleton = NULL;

GType deja_dup_network_get_type (void) G_GNUC_CONST;
DejaDupNetwork* deja_dup_network_get (void);
DejaDupNetwork* deja_dup_network_new (void);
DejaDupNetwork* deja_dup_network_construct (GType object_type);
static void deja_dup_network_can_reach_data_free (gpointer _data);
void deja_dup_network_can_reach (DejaDupNetwork* self,
                                 const gchar* url,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
gboolean deja_dup_network_can_reach_finish (DejaDupNetwork* self,
                                            GAsyncResult* _res_);
static gboolean deja_dup_network_can_reach_co (DejaDupNetworkCanReachData* _data_);
static void deja_dup_network_can_reach_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_);
static void deja_dup_network_update_connected (DejaDupNetwork* self);
static void deja_dup_network_set_connected (DejaDupNetwork* self,
                                     gboolean value);
static void deja_dup_network_update_metered (DejaDupNetwork* self);
GType deja_dup_filtered_settings_get_type (void) G_GNUC_CONST;
DejaDupFilteredSettings* deja_dup_get_settings (const gchar* subdir);
#define DEJA_DUP_ALLOW_METERED_KEY "allow-metered"
static void deja_dup_network_set_metered (DejaDupNetwork* self,
                                   gboolean value);
gboolean deja_dup_network_get_connected (DejaDupNetwork* self);
gboolean deja_dup_network_get_metered (DejaDupNetwork* self);
static GObject * deja_dup_network_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static void _deja_dup_network_update_connected_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void _deja_dup_network_update_metered_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void deja_dup_network_finalize (GObject * obj);
static void _vala_deja_dup_network_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_deja_dup_network_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);


static inline gpointer
deja_dup_network_get_instance_private (DejaDupNetwork* self)
{
	return G_STRUCT_MEMBER_P (self, DejaDupNetwork_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 32 "../libdeja/Network.vala"
	return self ? g_object_ref (self) : NULL;
#line 164 "Network.c"
}


DejaDupNetwork*
deja_dup_network_get (void)
{
	DejaDupNetwork* result = NULL;
	DejaDupNetwork* _tmp0_;
	DejaDupNetwork* _tmp2_;
	DejaDupNetwork* _tmp3_;
#line 30 "../libdeja/Network.vala"
	_tmp0_ = deja_dup_network_singleton;
#line 30 "../libdeja/Network.vala"
	if (_tmp0_ == NULL) {
#line 179 "Network.c"
		DejaDupNetwork* _tmp1_;
#line 31 "../libdeja/Network.vala"
		_tmp1_ = deja_dup_network_new ();
#line 31 "../libdeja/Network.vala"
		_g_object_unref0 (deja_dup_network_singleton);
#line 31 "../libdeja/Network.vala"
		deja_dup_network_singleton = _tmp1_;
#line 187 "Network.c"
	}
#line 32 "../libdeja/Network.vala"
	_tmp2_ = deja_dup_network_singleton;
#line 32 "../libdeja/Network.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 32 "../libdeja/Network.vala"
	result = _tmp3_;
#line 32 "../libdeja/Network.vala"
	return result;
#line 197 "Network.c"
}


static void
deja_dup_network_can_reach_data_free (gpointer _data)
{
	DejaDupNetworkCanReachData* _data_;
	_data_ = _data;
#line 24 "../libdeja/Network.vala"
	_g_free0 (_data_->url);
#line 24 "../libdeja/Network.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../libdeja/Network.vala"
	g_slice_free (DejaDupNetworkCanReachData, _data_);
#line 212 "Network.c"
}


void
deja_dup_network_can_reach (DejaDupNetwork* self,
                            const gchar* url,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	DejaDupNetworkCanReachData* _data_;
	DejaDupNetwork* _tmp0_;
	gchar* _tmp1_;
#line 24 "../libdeja/Network.vala"
	_data_ = g_slice_new0 (DejaDupNetworkCanReachData);
#line 24 "../libdeja/Network.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 24 "../libdeja/Network.vala"
	g_task_set_task_data (_data_->_async_result, _data_, deja_dup_network_can_reach_data_free);
#line 24 "../libdeja/Network.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../libdeja/Network.vala"
	_data_->self = _tmp0_;
#line 24 "../libdeja/Network.vala"
	_tmp1_ = g_strdup (url);
#line 24 "../libdeja/Network.vala"
	_g_free0 (_data_->url);
#line 24 "../libdeja/Network.vala"
	_data_->url = _tmp1_;
#line 24 "../libdeja/Network.vala"
	deja_dup_network_can_reach_co (_data_);
#line 243 "Network.c"
}


gboolean
deja_dup_network_can_reach_finish (DejaDupNetwork* self,
                                   GAsyncResult* _res_)
{
	gboolean result;
	DejaDupNetworkCanReachData* _data_;
#line 24 "../libdeja/Network.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../libdeja/Network.vala"
	result = _data_->result;
#line 24 "../libdeja/Network.vala"
	return result;
#line 259 "Network.c"
}


static void
deja_dup_network_can_reach_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_)
{
	DejaDupNetworkCanReachData* _data_;
#line 40 "../libdeja/Network.vala"
	_data_ = _user_data_;
#line 40 "../libdeja/Network.vala"
	_data_->_source_object_ = source_object;
#line 40 "../libdeja/Network.vala"
	_data_->_res_ = _res_;
#line 40 "../libdeja/Network.vala"
	deja_dup_network_can_reach_co (_data_);
#line 277 "Network.c"
}


static gboolean
deja_dup_network_can_reach_co (DejaDupNetworkCanReachData* _data_)
{
#line 35 "../libdeja/Network.vala"
	switch (_data_->_state_) {
#line 35 "../libdeja/Network.vala"
		case 0:
#line 288 "Network.c"
		goto _state_0;
#line 35 "../libdeja/Network.vala"
		case 1:
#line 292 "Network.c"
		goto _state_1;
		default:
#line 35 "../libdeja/Network.vala"
		g_assert_not_reached ();
#line 297 "Network.c"
	}
	_state_0:
#line 37 "../libdeja/Network.vala"
	_data_->_tmp0_ = g_network_monitor_get_default ();
#line 37 "../libdeja/Network.vala"
	_data_->_tmp1_ = _g_object_ref0 (_data_->_tmp0_);
#line 37 "../libdeja/Network.vala"
	_data_->mon = _data_->_tmp1_;
#line 306 "Network.c"
	{
#line 39 "../libdeja/Network.vala"
		_data_->_tmp2_ = g_network_address_parse_uri (_data_->url, (guint16) 0, &_data_->_inner_error0_);
#line 39 "../libdeja/Network.vala"
		_data_->socket = _data_->_tmp2_;
#line 39 "../libdeja/Network.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 314 "Network.c"
			goto __catch37_g_error;
		}
#line 40 "../libdeja/Network.vala"
		_data_->_tmp4_ = _data_->mon;
#line 40 "../libdeja/Network.vala"
		_data_->_tmp5_ = _data_->socket;
#line 40 "../libdeja/Network.vala"
		_data_->_state_ = 1;
#line 40 "../libdeja/Network.vala"
		g_network_monitor_can_reach_async (_data_->_tmp4_, (GSocketConnectable*) _data_->_tmp5_, NULL, deja_dup_network_can_reach_ready, _data_);
#line 40 "../libdeja/Network.vala"
		return FALSE;
#line 327 "Network.c"
		_state_1:
#line 40 "../libdeja/Network.vala"
		_data_->_tmp3_ = g_network_monitor_can_reach_finish (_data_->_tmp4_, _data_->_res_, &_data_->_inner_error0_);
#line 40 "../libdeja/Network.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 40 "../libdeja/Network.vala"
			_g_object_unref0 (_data_->socket);
#line 335 "Network.c"
			goto __catch37_g_error;
		}
#line 40 "../libdeja/Network.vala"
		_data_->result = _data_->_tmp3_;
#line 40 "../libdeja/Network.vala"
		_g_object_unref0 (_data_->socket);
#line 40 "../libdeja/Network.vala"
		_g_object_unref0 (_data_->mon);
#line 40 "../libdeja/Network.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 40 "../libdeja/Network.vala"
		if (_data_->_state_ != 0) {
#line 40 "../libdeja/Network.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 40 "../libdeja/Network.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 352 "Network.c"
			}
		}
#line 40 "../libdeja/Network.vala"
		g_object_unref (_data_->_async_result);
#line 40 "../libdeja/Network.vala"
		return FALSE;
#line 359 "Network.c"
	}
	goto __finally37;
	__catch37_g_error:
	{
#line 38 "../libdeja/Network.vala"
		_data_->e = _data_->_inner_error0_;
#line 38 "../libdeja/Network.vala"
		_data_->_inner_error0_ = NULL;
#line 43 "../libdeja/Network.vala"
		_data_->_tmp6_ = _data_->e;
#line 43 "../libdeja/Network.vala"
		_data_->_tmp7_ = _data_->_tmp6_->message;
#line 43 "../libdeja/Network.vala"
		g_warning ("Network.vala:43: %s", _data_->_tmp7_);
#line 44 "../libdeja/Network.vala"
		_data_->result = FALSE;
#line 44 "../libdeja/Network.vala"
		_g_error_free0 (_data_->e);
#line 44 "../libdeja/Network.vala"
		_g_object_unref0 (_data_->mon);
#line 44 "../libdeja/Network.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 44 "../libdeja/Network.vala"
		if (_data_->_state_ != 0) {
#line 44 "../libdeja/Network.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 44 "../libdeja/Network.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 388 "Network.c"
			}
		}
#line 44 "../libdeja/Network.vala"
		g_object_unref (_data_->_async_result);
#line 44 "../libdeja/Network.vala"
		return FALSE;
#line 395 "Network.c"
	}
	__finally37:
#line 38 "../libdeja/Network.vala"
	_g_object_unref0 (_data_->mon);
#line 38 "../libdeja/Network.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 38 "../libdeja/Network.vala"
	g_clear_error (&_data_->_inner_error0_);
#line 38 "../libdeja/Network.vala"
	g_object_unref (_data_->_async_result);
#line 38 "../libdeja/Network.vala"
	return FALSE;
#line 408 "Network.c"
}


static void
deja_dup_network_update_connected (DejaDupNetwork* self)
{
	GNetworkMonitor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 58 "../libdeja/Network.vala"
	g_return_if_fail (self != NULL);
#line 60 "../libdeja/Network.vala"
	_tmp0_ = g_network_monitor_get_default ();
#line 60 "../libdeja/Network.vala"
	_tmp1_ = g_network_monitor_get_network_available (_tmp0_);
#line 60 "../libdeja/Network.vala"
	_tmp2_ = _tmp1_;
#line 60 "../libdeja/Network.vala"
	deja_dup_network_set_connected (self, _tmp2_);
#line 428 "Network.c"
}


static void
deja_dup_network_update_metered (DejaDupNetwork* self)
{
	GNetworkMonitor* mon = NULL;
	GNetworkMonitor* _tmp0_;
	GNetworkMonitor* _tmp1_;
	DejaDupFilteredSettings* settings = NULL;
	DejaDupFilteredSettings* _tmp2_;
	gboolean allow_metered = FALSE;
	DejaDupFilteredSettings* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GNetworkMonitor* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
#line 63 "../libdeja/Network.vala"
	g_return_if_fail (self != NULL);
#line 65 "../libdeja/Network.vala"
	_tmp0_ = g_network_monitor_get_default ();
#line 65 "../libdeja/Network.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 65 "../libdeja/Network.vala"
	mon = _tmp1_;
#line 66 "../libdeja/Network.vala"
	_tmp2_ = deja_dup_get_settings (NULL);
#line 66 "../libdeja/Network.vala"
	settings = _tmp2_;
#line 67 "../libdeja/Network.vala"
	_tmp3_ = settings;
#line 67 "../libdeja/Network.vala"
	allow_metered = g_settings_get_boolean ((GSettings*) _tmp3_, DEJA_DUP_ALLOW_METERED_KEY);
#line 68 "../libdeja/Network.vala"
	_tmp5_ = mon;
#line 68 "../libdeja/Network.vala"
	_tmp6_ = g_network_monitor_get_network_metered (_tmp5_);
#line 68 "../libdeja/Network.vala"
	_tmp7_ = _tmp6_;
#line 68 "../libdeja/Network.vala"
	if (_tmp7_) {
#line 470 "Network.c"
		gboolean _tmp8_;
#line 68 "../libdeja/Network.vala"
		_tmp8_ = allow_metered;
#line 68 "../libdeja/Network.vala"
		_tmp4_ = !_tmp8_;
#line 476 "Network.c"
	} else {
#line 68 "../libdeja/Network.vala"
		_tmp4_ = FALSE;
#line 480 "Network.c"
	}
#line 68 "../libdeja/Network.vala"
	deja_dup_network_set_metered (self, _tmp4_);
#line 63 "../libdeja/Network.vala"
	_g_object_unref0 (settings);
#line 63 "../libdeja/Network.vala"
	_g_object_unref0 (mon);
#line 488 "Network.c"
}


DejaDupNetwork*
deja_dup_network_construct (GType object_type)
{
	DejaDupNetwork * self = NULL;
#line 24 "../libdeja/Network.vala"
	self = (DejaDupNetwork*) g_object_new (object_type, NULL);
#line 24 "../libdeja/Network.vala"
	return self;
#line 500 "Network.c"
}


DejaDupNetwork*
deja_dup_network_new (void)
{
#line 24 "../libdeja/Network.vala"
	return deja_dup_network_construct (DEJA_DUP_TYPE_NETWORK);
#line 509 "Network.c"
}


gboolean
deja_dup_network_get_connected (DejaDupNetwork* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 26 "../libdeja/Network.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 26 "../libdeja/Network.vala"
	_tmp0_ = self->priv->_connected;
#line 26 "../libdeja/Network.vala"
	result = _tmp0_;
#line 26 "../libdeja/Network.vala"
	return result;
#line 526 "Network.c"
}


static void
deja_dup_network_set_connected (DejaDupNetwork* self,
                                gboolean value)
{
#line 26 "../libdeja/Network.vala"
	g_return_if_fail (self != NULL);
#line 26 "../libdeja/Network.vala"
	if (deja_dup_network_get_connected (self) != value) {
#line 26 "../libdeja/Network.vala"
		self->priv->_connected = value;
#line 26 "../libdeja/Network.vala"
		g_object_notify_by_pspec ((GObject *) self, deja_dup_network_properties[DEJA_DUP_NETWORK_CONNECTED_PROPERTY]);
#line 542 "Network.c"
	}
}


gboolean
deja_dup_network_get_metered (DejaDupNetwork* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 27 "../libdeja/Network.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 27 "../libdeja/Network.vala"
	_tmp0_ = self->priv->_metered;
#line 27 "../libdeja/Network.vala"
	result = _tmp0_;
#line 27 "../libdeja/Network.vala"
	return result;
#line 560 "Network.c"
}


static void
deja_dup_network_set_metered (DejaDupNetwork* self,
                              gboolean value)
{
#line 27 "../libdeja/Network.vala"
	g_return_if_fail (self != NULL);
#line 27 "../libdeja/Network.vala"
	if (deja_dup_network_get_metered (self) != value) {
#line 27 "../libdeja/Network.vala"
		self->priv->_metered = value;
#line 27 "../libdeja/Network.vala"
		g_object_notify_by_pspec ((GObject *) self, deja_dup_network_properties[DEJA_DUP_NETWORK_METERED_PROPERTY]);
#line 576 "Network.c"
	}
}


static void
_deja_dup_network_update_connected_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 52 "../libdeja/Network.vala"
	deja_dup_network_update_connected ((DejaDupNetwork*) self);
#line 588 "Network.c"
}


static void
_deja_dup_network_update_metered_g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
#line 55 "../libdeja/Network.vala"
	deja_dup_network_update_metered ((DejaDupNetwork*) self);
#line 599 "Network.c"
}


static GObject *
deja_dup_network_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DejaDupNetwork * self;
	GNetworkMonitor* mon = NULL;
	GNetworkMonitor* _tmp0_;
	GNetworkMonitor* _tmp1_;
	GNetworkMonitor* _tmp2_;
	GNetworkMonitor* _tmp3_;
#line 48 "../libdeja/Network.vala"
	parent_class = G_OBJECT_CLASS (deja_dup_network_parent_class);
#line 48 "../libdeja/Network.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 48 "../libdeja/Network.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DEJA_DUP_TYPE_NETWORK, DejaDupNetwork);
#line 49 "../libdeja/Network.vala"
	_tmp0_ = g_network_monitor_get_default ();
#line 49 "../libdeja/Network.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 49 "../libdeja/Network.vala"
	mon = _tmp1_;
#line 51 "../libdeja/Network.vala"
	deja_dup_network_update_connected (self);
#line 52 "../libdeja/Network.vala"
	_tmp2_ = mon;
#line 52 "../libdeja/Network.vala"
	g_signal_connect_object ((GObject*) _tmp2_, "notify::network-available", (GCallback) _deja_dup_network_update_connected_g_object_notify, self, 0);
#line 54 "../libdeja/Network.vala"
	deja_dup_network_update_metered (self);
#line 55 "../libdeja/Network.vala"
	_tmp3_ = mon;
#line 55 "../libdeja/Network.vala"
	g_signal_connect_object ((GObject*) _tmp3_, "notify::network-metered", (GCallback) _deja_dup_network_update_metered_g_object_notify, self, 0);
#line 48 "../libdeja/Network.vala"
	_g_object_unref0 (mon);
#line 48 "../libdeja/Network.vala"
	return obj;
#line 644 "Network.c"
}


static void
deja_dup_network_class_init (DejaDupNetworkClass * klass)
{
#line 24 "../libdeja/Network.vala"
	deja_dup_network_parent_class = g_type_class_peek_parent (klass);
#line 24 "../libdeja/Network.vala"
	g_type_class_adjust_private_offset (klass, &DejaDupNetwork_private_offset);
#line 24 "../libdeja/Network.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_deja_dup_network_get_property;
#line 24 "../libdeja/Network.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_deja_dup_network_set_property;
#line 24 "../libdeja/Network.vala"
	G_OBJECT_CLASS (klass)->constructor = deja_dup_network_constructor;
#line 24 "../libdeja/Network.vala"
	G_OBJECT_CLASS (klass)->finalize = deja_dup_network_finalize;
#line 24 "../libdeja/Network.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEJA_DUP_NETWORK_CONNECTED_PROPERTY, deja_dup_network_properties[DEJA_DUP_NETWORK_CONNECTED_PROPERTY] = g_param_spec_boolean ("connected", "connected", "connected", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../libdeja/Network.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEJA_DUP_NETWORK_METERED_PROPERTY, deja_dup_network_properties[DEJA_DUP_NETWORK_METERED_PROPERTY] = g_param_spec_boolean ("metered", "metered", "metered", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 667 "Network.c"
}


static void
deja_dup_network_instance_init (DejaDupNetwork * self)
{
#line 24 "../libdeja/Network.vala"
	self->priv = deja_dup_network_get_instance_private (self);
#line 26 "../libdeja/Network.vala"
	self->priv->_connected = TRUE;
#line 27 "../libdeja/Network.vala"
	self->priv->_metered = FALSE;
#line 680 "Network.c"
}


static void
deja_dup_network_finalize (GObject * obj)
{
	DejaDupNetwork * self;
#line 24 "../libdeja/Network.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DEJA_DUP_TYPE_NETWORK, DejaDupNetwork);
#line 24 "../libdeja/Network.vala"
	G_OBJECT_CLASS (deja_dup_network_parent_class)->finalize (obj);
#line 692 "Network.c"
}


GType
deja_dup_network_get_type (void)
{
	static volatile gsize deja_dup_network_type_id__volatile = 0;
	if (g_once_init_enter (&deja_dup_network_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DejaDupNetworkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) deja_dup_network_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DejaDupNetwork), 0, (GInstanceInitFunc) deja_dup_network_instance_init, NULL };
		GType deja_dup_network_type_id;
		deja_dup_network_type_id = g_type_register_static (G_TYPE_OBJECT, "DejaDupNetwork", &g_define_type_info, 0);
		DejaDupNetwork_private_offset = g_type_add_instance_private (deja_dup_network_type_id, sizeof (DejaDupNetworkPrivate));
		g_once_init_leave (&deja_dup_network_type_id__volatile, deja_dup_network_type_id);
	}
	return deja_dup_network_type_id__volatile;
}


static void
_vala_deja_dup_network_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	DejaDupNetwork * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DEJA_DUP_TYPE_NETWORK, DejaDupNetwork);
#line 24 "../libdeja/Network.vala"
	switch (property_id) {
#line 24 "../libdeja/Network.vala"
		case DEJA_DUP_NETWORK_CONNECTED_PROPERTY:
#line 24 "../libdeja/Network.vala"
		g_value_set_boolean (value, deja_dup_network_get_connected (self));
#line 24 "../libdeja/Network.vala"
		break;
#line 24 "../libdeja/Network.vala"
		case DEJA_DUP_NETWORK_METERED_PROPERTY:
#line 24 "../libdeja/Network.vala"
		g_value_set_boolean (value, deja_dup_network_get_metered (self));
#line 24 "../libdeja/Network.vala"
		break;
#line 733 "Network.c"
		default:
#line 24 "../libdeja/Network.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../libdeja/Network.vala"
		break;
#line 739 "Network.c"
	}
}


static void
_vala_deja_dup_network_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	DejaDupNetwork * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DEJA_DUP_TYPE_NETWORK, DejaDupNetwork);
#line 24 "../libdeja/Network.vala"
	switch (property_id) {
#line 24 "../libdeja/Network.vala"
		case DEJA_DUP_NETWORK_CONNECTED_PROPERTY:
#line 24 "../libdeja/Network.vala"
		deja_dup_network_set_connected (self, g_value_get_boolean (value));
#line 24 "../libdeja/Network.vala"
		break;
#line 24 "../libdeja/Network.vala"
		case DEJA_DUP_NETWORK_METERED_PROPERTY:
#line 24 "../libdeja/Network.vala"
		deja_dup_network_set_metered (self, g_value_get_boolean (value));
#line 24 "../libdeja/Network.vala"
		break;
#line 766 "Network.c"
		default:
#line 24 "../libdeja/Network.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../libdeja/Network.vala"
		break;
#line 772 "Network.c"
	}
}



